import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalMoney } from '../../../scw/custom-marshalling.js';
import { unmarshalDate, unmarshalArrayOfObject } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalHostingCpanelUrls = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HostingCpanelUrls' failed as data isn't a dictionary.`);
  }
  return {
    dashboard: data.dashboard,
    webmail: data.webmail
  };
};
const unmarshalHostingOption = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HostingOption' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name
  };
};
const unmarshalHosting = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Hosting' failed as data isn't a dictionary.`);
  }
  return {
    controlPanelName: data.control_panel_name,
    cpanelUrls: data.cpanel_urls ? unmarshalHostingCpanelUrls(data.cpanel_urls) : undefined,
    createdAt: unmarshalDate(data.created_at),
    dnsStatus: data.dns_status,
    domain: data.domain,
    id: data.id,
    ipv4: data.ipv4,
    ipv6: data.ipv6,
    offerEndOfLife: data.offer_end_of_life,
    offerId: data.offer_id,
    offerName: data.offer_name,
    oneTimePassword: data.one_time_password,
    options: unmarshalArrayOfObject(data.options, unmarshalHostingOption),
    organizationId: data.organization_id,
    platformGroup: data.platform_group,
    platformHostname: data.platform_hostname,
    platformNumber: data.platform_number,
    projectId: data.project_id,
    protected: data.protected,
    region: data.region,
    status: data.status,
    tags: data.tags,
    updatedAt: unmarshalDate(data.updated_at),
    username: data.username
  };
};
const unmarshalDnsRecord = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'DnsRecord' failed as data isn't a dictionary.`);
  }
  return {
    name: data.name,
    priority: data.priority,
    status: data.status,
    ttl: data.ttl,
    type: data.type,
    value: data.value
  };
};
const unmarshalNameserver = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Nameserver' failed as data isn't a dictionary.`);
  }
  return {
    hostname: data.hostname,
    isDefault: data.is_default,
    status: data.status
  };
};
const unmarshalDnsRecords = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'DnsRecords' failed as data isn't a dictionary.`);
  }
  return {
    nameServers: unmarshalArrayOfObject(data.name_servers, unmarshalNameserver),
    records: unmarshalArrayOfObject(data.records, unmarshalDnsRecord),
    status: data.status
  };
};
const unmarshalControlPanel = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ControlPanel' failed as data isn't a dictionary.`);
  }
  return {
    available: data.available,
    logoUrl: data.logo_url,
    name: data.name
  };
};
const unmarshalListControlPanelsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListControlPanelsResponse' failed as data isn't a dictionary.`);
  }
  return {
    controlPanels: unmarshalArrayOfObject(data.control_panels, unmarshalControlPanel),
    totalCount: data.total_count
  };
};
const unmarshalListHostingsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListHostingsResponse' failed as data isn't a dictionary.`);
  }
  return {
    hostings: unmarshalArrayOfObject(data.hostings, unmarshalHosting),
    totalCount: data.total_count
  };
};
const unmarshalOfferProduct = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'OfferProduct' failed as data isn't a dictionary.`);
  }
  return {
    databasesQuota: data.databases_quota,
    emailAccountsQuota: data.email_accounts_quota,
    emailStorageQuota: data.email_storage_quota,
    hostingStorageQuota: data.hosting_storage_quota,
    maxAddonDomains: data.max_addon_domains,
    name: data.name,
    option: data.option,
    ram: data.ram,
    supportIncluded: data.support_included,
    vCpu: data.v_cpu
  };
};
const unmarshalOffer = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Offer' failed as data isn't a dictionary.`);
  }
  return {
    available: data.available,
    billingOperationPath: data.billing_operation_path,
    controlPanelName: data.control_panel_name,
    endOfLife: data.end_of_life,
    id: data.id,
    price: data.price ? unmarshalMoney(data.price) : undefined,
    product: data.product ? unmarshalOfferProduct(data.product) : undefined,
    quotaWarnings: data.quota_warnings
  };
};
const unmarshalListOffersResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListOffersResponse' failed as data isn't a dictionary.`);
  }
  return {
    offers: unmarshalArrayOfObject(data.offers, unmarshalOffer)
  };
};
const unmarshalResetHostingPasswordResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ResetHostingPasswordResponse' failed as data isn't a dictionary.`);
  }
  return {
    password: data.password
  };
};
const unmarshalSession = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Session' failed as data isn't a dictionary.`);
  }
  return {
    url: data.url
  };
};
const marshalCreateHostingRequestDomainConfiguration = (request, defaults) => ({
  update_all_records: request.updateAllRecords,
  update_mail_record: request.updateMailRecord,
  update_nameservers: request.updateNameservers,
  update_web_record: request.updateWebRecord
});
const marshalCreateHostingRequest = (request, defaults) => ({
  domain: request.domain,
  domain_configuration: request.domainConfiguration !== undefined ? marshalCreateHostingRequestDomainConfiguration(request.domainConfiguration) : undefined,
  email: request.email,
  language: request.language,
  offer_id: request.offerId,
  option_ids: request.optionIds,
  project_id: request.projectId ?? defaults.defaultProjectId,
  tags: request.tags
});
const marshalUpdateHostingRequest = (request, defaults) => ({
  email: request.email,
  offer_id: request.offerId,
  option_ids: request.optionIds,
  protected: request.protected,
  tags: request.tags
});

export { marshalCreateHostingRequest, marshalUpdateHostingRequest, unmarshalDnsRecords, unmarshalHosting, unmarshalListControlPanelsResponse, unmarshalListHostingsResponse, unmarshalListOffersResponse, unmarshalResetHostingPasswordResponse, unmarshalSession };
